/* Gfx init'n'stuff */
#include "gfx.h"
#include "starfield.h"

void gfxRender(void)
{
	int x; 
#ifdef SDL
	if (SDL_MUSTLOCK(sdl_surface))
	{
		if (SDL_LockSurface(sdl_surface) < 0) { return; }
	}
#endif

	cls();

	/* effects here yeah! */
	if (startime < 200) { starfieldmove(); }
	else { starfieldroto(); }

	/*load the palette*/
	palettepcx("ISO.PCX");
	/*showpcx(pcxfile, transparent color, x, y)*/
	showpcx("ISO.PCX",0,0,0);

	/*Color palette test*/
	x=256;
	while(x--) { putpixel(x,0,x); }

#ifdef SDL
	if (SDL_MUSTLOCK(sdl_surface))
	{
		SDL_UnlockSurface(sdl_surface);
	}
	SDL_UpdateRect(sdl_surface, 0, 20, 320, 200);
#else
	flip(dblbuf);
#endif
	waitaminute();
}

void gfxInit(void)
{
	RGB color;
	int alustus;

#ifdef SDL
	/*
		SDL 0x13h hack
		320x200 mode crashes so we have to
		use 320x240 and create "widescreen" borders :(

		...siis eiku ihan oikeesti mink vitun takia toi kaatuu
		en oo toki kyl jaksannu testata asiaa kun laitoin purkaten
		mutta vituttaa se silti
	*/
	SDL_Init(SDL_INIT_VIDEO);
	atexit(SDL_Quit);
#ifdef FULLSCREEN
	sdl_surface = SDL_SetVideoMode(320, 240, 0, SDL_SWSURFACE|SDL_FULLSCREEN);
#else
	sdl_surface = SDL_SetVideoMode(320, 240, 0, SDL_SWSURFACE);
#endif

	SDL_WM_SetCaption("SDL - int 13h",0);
	SDL_ShowCursor(0);

#else

	dblbuf=(char *)malloc(64000);

	if(!dblbuf)
	{
		printf("culli! out of memory.\n");
		exit(1);
	}

	textmode(0x13);
	cls();
#endif

	/*SDL version _WILL_ fuck up colors
    if setcolor has index value over 255*/
	for (alustus=0; alustus<64; alustus++)
	{
		color.red=alustus;
		color.green=0;
		color.blue=0;
		setcolor(alustus, &color);

		color.red=0;
		color.green=alustus;
		color.blue=0;
		setcolor(alustus+64, &color);

		color.red=0;
		color.green=0;
		color.blue=alustus;
		setcolor(alustus+128, &color);

		color.red=alustus;
		color.green=alustus;
		color.blue=alustus;
		setcolor(alustus+192, &color);
	}

	starfieldInit();
}

/* Clear screen */
void cls(void)
{
#ifdef SDL
	int i = 220*(sdl_surface->pitch/4)+320;
	while(i--) { ((unsigned int*)sdl_surface->pixels)[i] = 0; }
#else
	char* scr = dblbuf;
	char* scre = scr+320*200;
	while (scr<scre) { *scr++ = 0; }
#endif
}

void putpixel(int x, int y, int color)
{
	if ((x >= 0) && (x < 320) && (y >= 0) && (y < 200))
	{
#ifdef SDL
		((unsigned int*)sdl_surface->pixels)[(y+20)*(sdl_surface->pitch/4)+x] = SDL_RGB_Colortable[color];
#else
		dblbuf[y*320+x]=color;
#endif
	}
}

void waitaminute(void)
{
#ifdef SDL
	int timenow, time_calc;
	timenow = SDL_GetTicks();
	sleepnow += 17;
	time_calc = sleepnow - timenow;
	if (time_calc <= 0)	{ sleepnow = timenow; }
	else { SDL_Delay(time_calc); }
#else
	while ( (inportb(0x3DA)&8) != 0);
	while ( (inportb(0x3DA)&8) == 0);
#endif
}

void setcolor(int index, RGB *newdata)
{
#ifdef SDL
	if (index < 256)
	{
		SDL_RGB_Colortable[index] = (newdata->red*4)*0x010000 +
									(newdata->green*4)*0x000100 +
									(newdata->blue*4);
#ifdef BIGENDIAN
		INT_ENDIAN(SDL_RGB_Colortable[index]);
#endif
	}
#else
	outportb(0x3C8, index);
	outportb(0x3C9, newdata->red);
	outportb(0x3C9, newdata->green);
	outportb(0x3C9, newdata->blue);
#endif
}
