#ifndef GFX_H
#define GFX_H

#ifdef BIGENDIAN
#define INT_ENDIAN(x) (x) = ((((x)&0x00FF)<<8)+(((x)&0xFF00)>>8))
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

#ifdef SDL
#include <SDL/SDL.h>
SDL_Surface *sdl_surface;
int sleepnow;
int SDL_RGB_Colortable[256];
#else
#include <go32.h>
#include <sys/movedata.h>
#include <time.h>
#include <conio.h>
#include <dos.h>

#define flip(c) _dosmemputl(c, 64000/4, 0xA0000)
char *dblbuf;
#endif

#include "pcx.h"

typedef struct {
    int red;
    int green;
    int blue;
} RGB;

void gfxInit(void);
void gfxRender(void);
void setcolor(int index, RGB *newdata);
void waitaminute(void);
void putpixel(int x, int y, int color);
void cls(void);

#endif
